<?php
/**
 * This file aims to show you how to use this generated package.
 * In addition, the goal is to show which methods are available and the fist needed parameter(s)
 * You have to use an associative array such as:
 * - the key must be a constant beginning with WSDL_ from AbstractSoapClientbase class each generated ServiceType class extends this class
 * - the value must be the corresponding key value (each option matches a {@link http://www.php.net/manual/en/soapclient.soapclient.php} option)
 * $options = array(
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_URL => 'https://ds.hitpromo.net/product',
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_TRACE => true,
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_LOGIN => 'you_secret_login',
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_PASSWORD => 'you_secret_password',
 * );
 * etc....
 */
require_once __DIR__ . '/vendor/autoload.php';
/**
 * Minimal options
 */
$options = array(
    \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_URL => 'https://ds.hitpromo.net/product',
    \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_CLASSMAP => ClassMap::get(),
);
/**
 * Samples for Get ServiceType
 */
$get = new \ServiceType\Get($options);
/**
 * Sample call for getOutletProductList operation/method
 */
if ($get->getOutletProductList($customerNumber, $userCredential) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getInfo operation/method
 */
if ($get->getInfo($customerNumber, $userCredential, $productNumber, $outlet) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLastModified operation/method
 */
if ($get->getLastModified($customerNumber, $userCredential) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getProductFamilyFromPart operation/method
 */
if ($get->getProductFamilyFromPart($customerNumber, $userCredential, $partNumber) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getPartsFromProductFamily operation/method
 */
if ($get->getPartsFromProductFamily($customerNumber, $userCredential, $productNumber) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getTopSellers operation/method
 */
if ($get->getTopSellers($customerNumber, $userCredential, $count, $month, $year) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getColors operation/method
 */
if ($get->getColors($customerNumber, $userCredential, $productNumber, $includeOutlet) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSetupCharges operation/method
 */
if ($get->getSetupCharges($customerNumber, $userCredential, $productNumber) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getImages operation/method
 */
if ($get->getImages($customerNumber, $userCredential, $productNumber) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getProductDataCM operation/method
 */
if ($get->getProductDataCM($customerNumber, $userCredential, $productNumbers) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getInfoMulti operation/method
 */
if ($get->getInfoMulti($customerNumber, $userCredential, $productNumbers, $outlet) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getProductSizes operation/method
 */
if ($get->getProductSizes($customerNumber, $userCredential, $productNumber) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getProductPackingData operation/method
 */
if ($get->getProductPackingData($customerNumber, $userCredential, $productNumber) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getProductArtTemplates operation/method
 */
if ($get->getProductArtTemplates($customerNumber, $userCredential, $productNumber) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getActiveProducts operation/method
 */
if ($get->getActiveProducts($customerNumber, $userCredential, $includeOutletAndCustom) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getProductsDeactivated operation/method
 */
if ($get->getProductsDeactivated($customerNumber, $userCredential) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCategories operation/method
 */
if ($get->getCategories($customerNumber, $userCredential) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getProductsBySubcategory operation/method
 */
if ($get->getProductsBySubcategory($customerNumber, $userCredential, $subcategoriesIds) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getProductDecoration operation/method
 */
if ($get->getProductDecoration($customerNumber, $userCredential) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Samples for Is ServiceType
 */
$is = new \ServiceType\Is($options);
/**
 * Sample call for isProductRush operation/method
 */
if ($is->isProductRush($customerNumber, $userCredential, $productNumber) !== false) {
    print_r($is->getResult());
} else {
    print_r($is->getLastError());
}
